"""Install method.

$Id: Install.py 49215 2007-09-14 07:02:40Z dbaty $
"""

from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

from Products.CMFNotification.config import PROJECT_NAME, GLOBALS, DEFAULT_ROLES, CONFIGLETS
from Products.CMFNotification.permissions import SUBSCRIBE_PERMISSION
from Products.CMFNotification.NotificationTool import ID
from Products.CMFNotification.NotificationTool import NotificationTool

from Products.Archetypes.Extensions.utils import install_subskin


def install(self):
    """Install CMFNotification."""
    out = StringIO()

    install_subskin(self, out, GLOBALS)

    ## Add tool
    portal = getToolByName(self, 'portal_url').getPortalObject()
    if getToolByName(portal, ID, None) is None:
        t = NotificationTool()
        portal._setObject(ID, t)

    ## Add configlet
    panel = getToolByName(self, 'portal_controlpanel')
    if panel is not None:
        existing = panel.enumConfiglets(group='Products')
        existing = [c['id'] for c in existing]
        for configlet in CONFIGLETS:
            if configlet['id'] not in existing:
                panel.registerConfiglet(**configlet)

    ## Add portlet to the right slots.
    right_slots = list(portal.getProperty('right_slots'))
    if 'here/portlet_notification/macros/portlet' not in right_slots:
        right_slots.insert(0, 'here/portlet_notification/macros/portlet')
        portal.manage_changeProperties(right_slots=right_slots)

    ## Set default roles for subscribe permission
    portal.manage_permission(SUBSCRIBE_PERMISSION, DEFAULT_ROLES)

    print >> out, "Successfully installed %s." % PROJECT_NAME
    return out.getvalue()
