"""Utility methods for CMFNotification.

$Id: utils.py 33881 2006-11-18 15:42:29Z dbaty $
"""

from AccessControl import getSecurityManager
from Products.PageTemplates.Expressions import getEngine
from Products.PageTemplates.Expressions import SecureModuleImporter

from Products.CMFCore.utils import getToolByName


def getExpressionContext(obj, extra_bindings=None):
    """An expression context provides names for TALES expressions.

    Based on ``DCWorkflow.Expression`` and ``CMFCore.Expression``. We
    provide basic bindings (``here``, ``portal``, ``author``,
    etc.). ``extra_bindings`` are then added.
    """
    portal = getToolByName(obj, 'portal_url').getPortalObject()
    mtool = getToolByName(portal, 'portal_membership')

    data = {
        'here': obj,
        'context': obj,
        'nothing': None,
        'portal': portal,
        'request': getattr(obj, 'REQUEST', None),
        'modules': SecureModuleImporter,
        'author': mtool.getAuthenticatedMember(),
        }

    if extra_bindings is not None:
        data.update(extra_bindings)

    return getEngine().getContext(data)
